B 牛牛的算术

题目地址:

https://ac.nowcoder.com/acm/contest/7079/B

基本思路:

我们发现这个是连乘的形式,那么如果,那么必然会取模成0,
所以我们考虑的部分怎么算,
我们将式子拆分一下: ,
最后一部分很明显是一个前缀和,然后第二个部分也是一个前缀和,
所以我们预处理两个前缀和就能的预处理出所有小于的结果。

参考代码:

#pragma GCC optimize(2)
#pragma GCC optimize(3)
#include <bits/stdc++.h>
using namespace std;
#define IO std::ios::sync_with_stdio(false); cin.tie(0)
#define ll long long
#define SZ(x) ((int)(x).size())
#define all(x) (x).begin(), (x).end()
#define rep(i, l, r) for (int i = l; i <= r; i++)
#define per(i, l, r) for (int i = l; i >= r; i--)
#define mset(s, _) memset(s, _, sizeof(s))
#define pb push_back
#define pii pair <int, int>
#define mp(a, b) make_pair(a, b)
#define INF 0x3f3f3f3f

inline int read() {
  int x = 0, neg = 1; char op = getchar();
  while (!isdigit(op)) { if (op == '-') neg = -1; op = getchar(); }
  while (isdigit(op)) { x = 10 * x + op - '0'; op = getchar(); }
  return neg * x;
}
inline void print(int x) {
  if (x < 0) { putchar('-'); x = -x; }
  if (x >= 10) print(x / 10);
  putchar(x % 10 + '0');
}
const ll mod = 199999;
string s;
ll sum1[200000],sum2[200000],ans[200000];
int change(string str) {
  int sum = 0;
  for (auto it : str) sum = sum * 10 + it - '0';
  return sum;
}
void pre() {
  rep(i, 1, mod) sum1[i] = (sum1[i - 1] + i) % mod;
  rep(i, 1, mod) sum2[i] = (sum2[i - 1] + i * sum1[i] % mod) % mod;
  ans[0] = 1;
  rep(i, 1, mod) ans[i] = ans[i - 1] * i % mod * sum2[i] % mod;
}
signed main() {
  IO;
  pre();
  int t;
  cin >> t;
  while (t--){
    cin >> s;
    if(s.length() > 6) {
      cout << 0 << '\n';
      continue;
    }
    int n = change(s);
    if(n >= 200000){
      cout << 0 << '\n';
      continue;
    }
    cout << ans[n] << '\n';
  }
  return 0;
}